/* 

    >>> errorhandling <<<

    ERR(no)	   no: 0=no error (print status)
    			>=9000	FATAL=exit
 
*/

#ifndef ERROR_HANDLING	/* define once only */
#define ERROR_HANDLING
#include "sighand.h"

// #ifdef DEBUG
#define ERR(no)  err_pg_dbg(no,__LINE__,__FILE__) /* + 2 = 4 asm-commands */
// #else
// #define ERR(no)  err_pg(no)  /* not needed? */
// #endif

extern int err_fatal;	/* for communication between functions */
extern int vvv;		/* verbose-mode 1=outx,2=mem,4=...      */

void err_pg(int no);
void err_pg_dbg(int no, int line, char *file);

/* -----------------------------------------------------------------
    wie geht man am besten mit Fehlern um? 
    es ist nicht immer sinnvoll, sofort exit(1) auszufuehren 
    globale error_line etc. variablen
    z.B. Wdhl. merken aber nur 1.,2., und letzte Meldung ausgeben
    diese Variante erzeugt viel exe-code (belastet cache?)
    vielleicht DEBUG-mode = full info
               NoDBG=fehlernummer + error.tex (errorprozedur)
               EEX(ErrorNo)
   ----------------------------------------------------------------- */
#define EE()		{printf("\n%s L%d: ",__FILE__,__LINE__);}
#define IFNAN(r,x)	{if(isnan(r)!=0){EE();printf(x"=%g\n",r);}}
#define E0(s1)		{EE();printf("error "s1);}
#define E1(s1,a1)	{EE();printf("error "s1,a1);}
#define E2(s1,a1,a2)	{EE();printf("error "s1,a1,a2);}
#define E3(s1,a1,a2,a3)	{EE();printf("error "s1,a1,a2,a3);}
#define FE()		{printf("\n");STKo();err_pg(0);exit(1); }
#define F0(s1)		{EE();printf("fatal "s1);FE();}
#define F1(s1,a1)	{EE();printf("fatal "s1,a1);FE();}
#define F2(s1,a1,a2)	{EE();printf("fatal "s1,a1,a2);FE();}
#define F3(s1,a1,a2,a3)	{EE();printf("fatal "s1,a1,a2,a3);FE();}
#endif	/* -------------------- end-error ---------------------------- */
