#ifndef __SPINS_H
#define __SPINS_H 1

#include <stdlib.h>	/* Achtung bei long<->int-Mischmasch */
#include <stdio.h>
#include <string.h>	/* strcat, strcmp, usw. */
#include <math.h>
#include "spinsdef.h"	/* define Lsize Dsize Isize etc. */
#include "config.h"
#include "sighand.h"	/* signalhandler -> ini_handler, sig1 */
#include "defs.h"
#include "modeldef.h"	/* specialy system */
#include "mem.h"

extern int	algo;	/* algorithm 0=lanzcos,1=richter,2=wenzel2x2 */
extern int	x_p;	/* output format for |x> <=3 */
extern int      save_mode;  /* setup after crash possible */
extern int      checkpoint; /* setup after crash possible */

/* set or unset the following macros in config.h and not here
   (here we have only default values) */
/* IFz(x) produced a cpp-error on cray, so we changed it back 1998-148 */
#ifndef IFz		/* may be predefined in config.h */
#define IFz	1  	/* 1 = XYZ-JJ-model, 0 = XY-JJ-model */
#endif
#ifndef NEW
#define NEW	4	/* number of lowest eigenvalues   >=NEV,>ne0 */
#endif
#ifndef NEV
#define NEV	4	/* max. number of eigenvectors  <=(NEW-NE0) */
#endif

/* last mod: 1998-148 cray-cc don not accept 0LL */
#if defined(S_llong) &&  NN > CM(8,4,4)*S_long
/* ========================== long long =============================== */
#if     NN <8*S_llong
#define M0F   ((1ULL<<NN)-1)
#elif   NN==8*S_llong
#define M0F   (~0ULL)
#else
#define M0F   ((((tbase)1)<<NN)-1)
/* #error "NN>8*sizeof(llong)" */
#endif
#else
/* ========================== long ==================================== */
#if   S_long == 8
#if 0
#define MAA   (0xAAAAAAAAAAAAAAAAUL)	/* Bitmuster alles down's */
#define M55   (0x5555555555555555UL)	/* Bitmuster alles up's */
#endif
#elif S_long == 4
#if 0
#define MAA   (0xAAAAAAAAUL)		/* Bitmuster alles down's */
#define M55   (0x55555555UL)		/* Bitmuster alles up's */
#endif
#else
#error "sizeof(long) not 4 or 8"
#endif  
#if     NN <8*S_long
#define M0F   ((1l<<NN)-1)
#elif   NN==8*S_long
#define M0F   (~0l)
#else
#define M0F   ((((tbase)1)<<NN)-1)
/* #error "NN>8*sizeof(long)" */
#endif
#endif

#ifndef CM			/* CaseModel => config.h */
#error define CM(JJ,tJ,tU) JJ	/* default=JJ else tJ or tU model */
#endif

#ifndef N0
#define N0 NN
#endif

/* smallest type for base configurations dN..d1 uN..u1 */
/* cray: sizeof() short=int=long=longlong! but bits are different!? */
/* 1998-148: cray (short)0100=0000 (short)0080=ff80 !?
   1998-150: tbase1=1bit/site, tbase = CM ( tbase1, tbase[u,d], .. )
   2002apr: Nd,...,3d,2d,1d,Nu...,3u,2u,1u in one word
   ToDo: move to hilbert.h (tbase.h is only for l1[])
   BitsPerSite=CM(1,2,2)
 */
#if   CM(1,2,2)*NN<=8*S_char   &&  S_char  < S_short
  typedef unsigned char      tbase1;    /* CHAR_BIT = 8 */
#elif CM(1,2,2)*NN<=8*S_short  &&  S_short < S_int
  typedef unsigned short     tbase1;
#elif CM(1,2,2)*NN<=8*S_int
  typedef unsigned int       tbase1;
#elif CM(1,2,2)*NN<=8*S_long
  typedef unsigned long      tbase1;
#elif defined(S_llong) && (CM(1,2,2)*NN<=8*S_llong)
  typedef unsigned long long tbase1;
#else
# define B2size ( CM(1,2,2)*((NN-1)/(8*S_int)+1)) /* int=fastest */
                              /* usually Bsize <= (B2size*S_int) */
#include "vlint.h"            /* speed loss! avoid this! */
typedef class vlint tbase1;   /* unsigned int[] */
#endif
typedef tbase1 tbase;

#include "symmetry.h"	/* need declaration of tbase1 */


extern ULong  n1,n2;			/* Matrixsize , Linsize         */
extern int	pew;			/* number eigenvalue to check   */
extern zahl ew[NEW];                 	/* eigenvalues  (max# NEW)	*/
extern FILE *f1;			/* output file			*/
extern ULong *base2;
/* ERR(600): try one of unsigned char, short, int, long, double(?) */
/*            ===========> consumes more memory  */
#ifndef ATnorm2
#define ATnorm2 unsigned char	/* range=0..255^sizeof(Tnorm2), for arrays */
#endif
#ifndef Tnorm2
#define Tnorm2 ULLong           /* prefactor, default=ULLong (try double) */
#endif
extern ATnorm2 *norm2;		/* vector idx->sym-idx, norm(sym-idx)	*/
extern minfo_t m_n2;            /* memory status info for norm2-array */
extern int  base2ok;		/* flag: norm2 is initialized		*/
extern ULong h_n1;		/* # of stored lines in hxy (obsolete)	*/
extern ULong hfmax;		/* max. number of hxy-elements on disk	*/
#if 0				/* never defined, better than comments?	*/
 extern cplx sqrt(x)cplx x;{return(pow(x,0.5));}/* only for buggy GNUC	*/
#endif

/* ------- class base_ => b_ ----------------------------------- */
#define MaxSBase	(2*MaxSym+2)	/* should be larger than 2*MaxSym+1 */
struct sbase{		/* viel memory, ueber spez. fkt speicher zuordnen */
  tbase  skfg;		/* b_smallest */
  Tnorm2 norm2;		/* norm^(-2),   <kfg|skfg),  N=10 S=5/2 norm2>1e9 */
  tphase sign;		/* phase, real=int=+1,-1 */
  int    num;		/* number of configs (mostly 2*MaxSym+2) */
  int    o;		/* option: 0=fullbase,1=smallest,2=ifsmallest */
  tbase  ib[MaxSBase];	/* large object -> class for array proof? */
  tphase is[MaxSBase];};

	/* Flip(kfg,i1,i2) kfg^flip[i1][i2] last change: Apr98 JS */
#if   CM(1,0,0)
#define Flip(kfg,i1,i2) ((kfg) ^ ((tbase)1)<<(i1) ^ ((tbase)1)<<(i2))
#elif CM(0,1,1)				/* u<=>d sites i,j */
#define Flip(kfg,i1,i2) ((kfg) ^ ((tbase)3)<<((i1)*2) ^ ((tbase)3)<<((i2)*2) )
#endif

/* ToDo: alloc in dynamic way and store max needed size! */
/* NZXMAX max# of elements of one line in a HBlock, smaller is faster */
#define NZXMAX	1024
/* --------------- this is for pthread code ------------- 
 * all arguments needed by sub-functions to calculate |H|m> or <v1|H|v0> (?)
 *  within threads are stored here
 */
typedef struct shbuf {	/* buffer to calculate a H-line H|icfg> */
  int block;		/* compute thread or vector-blockNo (0..B_NUM-1) */
  ULong i;              /* index of configuration where H acts on v2.26 */
  tvec *v0, *v1;        /* pointer to v0, v1 (v1+=H*v0) */
  /* ToDo: pointer to sbase buffer bi, bj; simplify nhm() args */
  cplx r;               /* r=<n|H|v0>_block useless? */
  double nhn;           /* return diagonal element <n|H|n> where n=i, zahl? */
  int n;                /* num_stored_elements in el[] */
  struct shelem {
    tbase kj;		/* kfg or smallest kfg */
    ULong j;		/* y, column, index of configuration kj */
    cplx  r;		/* matrix element H[x,y]=H[i,j] */
    /* ToDo: char para;  parameter index J1, J2 etc. */
    /* add norm2 for better wopij()??? */
  } el[NZXMAX]; /* [B_NUM] only needed for storing and non-disk version? */
} thbuf;

/*  thbuf *hbuf; hbuf=alloc_hbuf(); ... free_hbuf(hbuf); */
thbuf *alloc_hbuf( void );
void  *free_hbuf( thbuf *pb );


#include "symmetry.h"
static inline zahl norm(zahl r){return(r*r);}
char *sclock(long t);
/* --------------- in-out-functions ---------------------------- */
char *ckfg(tbase ic); /* Spinconfiguration |..43210> zB: |...u.dudu> */
char *outc(cplx r);  /* complexe zahl */    
char *outphase(tphase r);
void nl(FILE *f);
void outew(FILE *f);

/* m1=0: <vHn> m1=1: <nHn> */
cplx hamilton_nhv(ULong i,tvec *v0,thbuf *hbuf,int m1);
cplx fast_nhv(ULong i,tvec *v0,double *nhn,thbuf *hbuf); /* <vHn>,<nHn> */
cplx hamilton(tvec *v0,tvec *v1);         /* v1=H*v0+v1, r=<v0|H*v0> */
/* void storeh(); --obsolete-- */

/* ================= inline - functions ======================= */

static inline int phase_eq(tphase p1,tphase p2){
#if VecType & 4	/* remove rounding errors! 1998-170 not exact!!! */
   return( (fabs(p1-p2)<1e-6)? 1: 0);}	/* Norm faster as fabs() ????? */
#else
   return( (p1==p2)? 1: 0);}
#endif

/* send job (function worker) to threads and restart them */
void parallel_start( int thread_i, void (*worker)(void *data), void *data );
 
/* waiting for threads OR dummy for non-threaded */
void parallel_wait( int thread_i );



#endif
/* last line should be a newline, else cray-cc prints warnings */

